// this is a very basic template. use it to start writing your own effects.
// if you want effects with lighting start from one of the GouraudXXXX or PhongXXXX effects

// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

//transforms
float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (EX9)
float4x4 tP: PROJECTION;
float4x4 tWVP: WORLDVIEWPROJECTION;



////////////////////////////////////////////////
/// 4 hard coded blob input params
/// array elements are: x,y,strength
float3 blob1 <string uiname="blob1";> ={0,0,0};
float3 blob2 <string uiname="blob2";> ={0,0,0};
float3 blob3 <string uiname="blob3";> ={0,0,0};
float3 blob4 <string uiname="blob4";> ={0,0,0};
//// threshold
float tresh <string uiname="tresh";> =0;
float offset   <string uiname="offset";> =5;


struct vs2ps
{
    float4 Pos  : POSITION;
    float2 TexCd : TEXCOORD0;
};

// --------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------
vs2ps VS(
    float4 PosO  : POSITION,
    float4 TexCd : TEXCOORD0)
{
    //inititalize all fields of output struct with 0
    vs2ps Out = (vs2ps)0;

    //transform position
    Out.Pos = mul(PosO, tWVP);
    
    //texturecoordinates
    Out.TexCd = TexCd;

    return Out;
}

// --------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// --------------------------------------------------------------------------------------------------
// 2D meataball soft edge
//// pseudo code is:
//// d=distance from actual pixel to blob center
//// pixel strength=blob strength/d*d
//// ran for each blob
float4 PS_a(vs2ps In): COLOR
{

    float2 p1={blob1[0],blob1[1]} ;
    float d1=distance(In.TexCd,p1) ;
    float acc=blob1[2]/(d1*d1) ;
     ////
     float2 p2={blob2[0],blob2[1]} ;
    float d2=distance(In.TexCd,p2) ;
    acc+=blob2[2]/(d2*d2) ;
    /////
     float2 p3={blob3[0],blob3[1]} ;
    float d3=distance(In.TexCd,p3) ;
    acc+=blob3[2]/(d3*d3) ;
    //
     float2 p4={blob4[0],blob4[1]} ;
    float d4=distance(In.TexCd,p4) ;
    acc+=blob4[2]/(d3*d4) ;

    float col=(acc/tresh )-offset;



    return col;

}
// 2D meataball hard edge

float4 PS_b(vs2ps In): COLOR
{

    float2 p1={blob1[0],blob1[1]} ;
    float d1=distance(In.TexCd,p1) ;
    float acc=blob1[2]/(d1*d1) ;
     ////
     float2 p2={blob2[0],blob2[1]} ;
    float d2=distance(In.TexCd,p2) ;
    acc+=blob2[2]/(d2*d2) ;
    /////
     float2 p3={blob3[0],blob3[1]} ;
    float d3=distance(In.TexCd,p3) ;
    acc+=blob3[2]/(d3*d3) ;
    //
     float2 p4={blob4[0],blob4[1]} ;
    float d4=distance(In.TexCd,p4) ;
    acc+=blob4[2]/(d3*d4) ;


    float treshcol=acc>tresh;


    return treshcol;
}

// --------------------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------------------

technique metaBall2Dsoft
{
    pass P0
    {

        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS_a();
    }
}
technique metaBall2Dhard
{
    pass P0
    {

        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS_b();
    }
}
